massiveextender =
{
	REQUIRE: function(module)
	{
		if(!module)
		{
			//alert("massiveextender: Missing required module");
			throw "massiveextender: Missing required module";
		}
		return module;
	},

	BOOT: function(appsetupstruct)
	{
		massiveextender.Init.RegisterWindowListeners(appsetupstruct.listeners)
	},
	
	Init:
	{
		_elementlisteners: null,
		RegisterElementListeners: function()
		{
			let _listeners = massiveextender.Init._elementlisteners;
			if(!_listeners)
				return;
			for(let id in _listeners)
			{
				let element = document.getElementById(id);
				if (element)
					for(let event in _listeners[id])
						element.addEventListener(event,
								_listeners[id][event][0], _listeners[id][event][1]);
			}
		},
		
		RegisterWindowListeners: function(listeners)
		{
			massiveextender.Init._elementlisteners = listeners.byid;

			let eventid = "load";
			window.addEventListener(eventid,
					massiveextender.Init.RegisterElementListeners, false);
			if(listeners.window[eventid])
				window.addEventListener(eventid, listeners.window[eventid], false);

			eventid = "unload";
			if(listeners.window[eventid])
				window.addEventListener(eventid, listeners.window[eventid], false);
		}
	}
}