if(massiveextender)
{
	massiveextender.Helpers = { }
	
	let $ns =
	massiveextender.Helpers.NS = 
	{
		makensobject: function(nsuri, nstypicalpfxlist)
		{
			var nsobject =
			{
				uri: nsuri,
				toString: function() this.uri
			}
			return nsobject;
		}
	}

	$ns["XUL"] = 		$ns.makensobject("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", ["xul"]);
	$ns["nsNC"] =		$ns.makensobject("http://home.netscape.com/NC-rdf#", ["NC"]);
	$ns["mozEM"] =		$ns.makensobject("http://www.mozilla.org/2004/em-rdf#", ["em"]);

	$ns["XML"] =		$ns.makensobject("http://www.w3.org/XML/1998/namespace", ["xml"]);
	$ns["XSLT"] =		$ns.makensobject("http://www.w3.org/1999/XSL/Transform", ["xslt", "xsl"]);
	$ns["XLink"] =		$ns.makensobject("http://www.w3.org/1999/xlink", ["xlink"]);
	$ns["XSD"] = 		$ns.makensobject("http://www.w3.org/2001/XMLSchema#", ["xsd", "xs"]);

	$ns["XHTML"] =		$ns.makensobject("http://www.w3.org/1999/xhtml", ["xhtml"]);
	$ns["HTML"] =		$ns.makensobject("http://www.w3.org/HTML/1998/html4", ["html"]);
	$ns["SVG"] =		$ns.makensobject("http://www.w3.org/2000/svg", ["svg"]);
	$ns["MathML"] =		$ns.makensobject("http://www.w3.org/1998/Math/MathML", ["mathml", "math"]);
	$ns["Atom"] =		$ns.makensobject("http://www.w3.org/2005/Atom", ["atom"]);

	$ns["SOAP"] = 		$ns.makensobject("http://schemas.xmlsoap.org/soap/envelope/", ["soap"]);

	$ns["RDFs"] =		$ns.makensobject("http://www.w3.org/2000/01/rdf-schema#", ["rdfs"]);
	$ns["RDF"] =		$ns.makensobject("http://www.w3.org/1999/02/22-rdf-syntax-ns#", ["rdf", "RDF"]);

	$ns["OWL"] =		$ns.makensobject("http://www.w3.org/2002/07/owl#", ["owl"]);
	$ns["OWL2"] =		$ns.makensobject("http://www.w3.org/2006/12/owl2#", ["owl2"]);
	$ns["dcTerms"] = 	$ns.makensobject("http://purl.org/dc/terms/", ["dcterms"]);
	$ns["dcMI"] =		$ns.makensobject("http://purl.org/dc/dcmitype/", ["dcmi"]);
	$ns["dc"] =			$ns.makensobject("http://purl.org/dc/elements/1.1/", ["dc"]);

	$ns["Annotea"] = 	$ns.makensobject("http://www.w3.org/2000/10/annotation-ns#", ["annotea"]);
	$ns["Bookmark"] = 	$ns.makensobject("http://www.w3.org/2002/01/bookmark#");
	$ns["FOAF"]	=		$ns.makensobject("http://xmlns.com/foaf/0.1/", ["foaf"]);
	$ns["Contact"] =	$ns.makensobject("http://www.w3.org/2000/10/swap/pim/contact#", ["contact"]);


	let $dom =
	massiveextender.Helpers.DOM =
	{
		byid: function(idstr)
		{
			return document.getElementById(idstr);
		},
		bysel: function(selector, element, all)
		{
			if(!element)
				element = document;
			return all ? element.querySelectorAll(selector) : element.querySelector(selector);
		},
		_defaultparser: null,
		get defaultparser()
		{
			if(!$dom._defaultparser)
				$dom._defaultparser = new DOMParser();
			return $dom._defaultparser;
		},
		parse: function(xmlobject, mimetype, parser)
		{
			let element = null;
			try
			{
				let useparser = parser || $dom.defaultparser;
				let usemimetype = mimetype || "text/xml";
				let usexmlobject = typeof(xmlobject == 'xml') ? xmlobject.toXMLString() : xmlobject;
				element = useparser.
						parseFromString(usexmlobject, usemimetype).
						documentElement;
			}
			catch(ex) { }
			return element;
		}
		
	}
	
	const Cc = Components.classes;
	const Ci = Components.interfaces;
	const Cr = Components.results;
	// TODO (med): much of this stuff inspired by Menu Editor xpconnect shortcuts now seems to be
	// superfluos since it's easier to copy contract ids from the docs and paste them verbatim;
	// possibly invent something more meaningful and/or utilize xpcom utils/fuel; will need
	// some refactoring then
	let $xpc =
	massiveextender.Helpers.XPC =
	{
		CrInst: function(contractstr, interfacestr, providerstr)
		{
			if(!providerstr)
				providerstr = "mozilla.org";
			return Cc["@" + providerstr + "/" + contractstr].
					createInstance(Ci[interfacestr]);
		},
		instance: function(contractstr, interfacestr)
		{
			return Cc[contractstr].createInstance(Ci[interfacestr]);
		},
	
		GetSvc: function(contractstr, interfacestr, providerstr)
		{
			if(!providerstr)
				providerstr = "mozilla.org";
			return Cc["@" + providerstr + "/" + contractstr].
					getService(Ci[interfacestr]);
		},
		service:
		{
			_nio: null,
			get nio()
			{
				return 	$xpc.service._nio ||
						($xpc.service._nio =
								$xpc.service.byid("@mozilla.org/network/io-service;1","nsIIOService"));
			},
			
			_strings: null,
			get strings()
			{
				return 	$xpc.service._strings ||
						($xpc.service._strings =
								$xpc.service.byid("@mozilla.org/intl/stringbundle;1", "nsIStringBundleService"));
			},
			
			byid: function(contractstr, interfacestr)
			{
				return Cc[contractstr].getService(Ci[interfacestr]);
			}
		},
		
		objects:
		{
			makestrings: function(ids, urls)
			{
				var strings =
				{
					ids: [],
					urls: [],
					bundles: [],
					add: function(moreids, moreurls)
					{
						let _this = this;
						let ffilterids = function(domid)
								{
									let bundle = $dom.byid(domid).stringBundle;
									_this.bundles.push(bundle);
									_this.ids.push(domid);
									return false;
								}
						let ffilterurls = function(propurl)
								{
									let bundle = $xpc.service.strings.
											createBundle(propurl);
									_this.bundles.push(bundle);
									_this.urls.push(propurl);
									return false;
								}
						if(moreids)
							moreids.filter(ffilterids);
						if(moreurls)
							moreurls.filter(ffilterurls);
					},
					// key - key into string bundle
					// values - substitutes for the %[xx$]S mnenomics (optional)
					// plural - number to decide which plural form to use
					get: function(key, values, plural)
					{
						let fmap = function(bundle)
						{
							let str = null;
							try
							{
								str = values ?
										bundle.formatStringFromName(key, values, values.length) :
										bundle.GetStringFromName(key);
							}
							catch(ex) {/*silent*/}
							if(!str)
								return false;
							if(!plural)
								return str;
							// we have an plural form here
							return $u.plural(plural, str);
						}
						let result = this.bundles.map(fmap);
						return (result.length > 0) ? result[0] : null;
					}
				}
				strings.add(ids, urls);
				return strings;
			}
		},

		c: Components.classes,
		i: Components.interfaces,
		r: Components.results
	}

	let $u =
	massiveextender.Helpers.Utilities =
	{
		url: function(spec)
		{
			return $xpc.service.nio.newURI(spec, null, null);
		},
		
		plural: function(num, pluralforms)
		{
			if(!$u.PluralForms)
				Components.utils.import("resource://gre/modules/PluralForm.jsm", $u);
			return $u.PluralForm.get(num, pluralforms);
		}
			
	}

	let $xre =
	massiveextender.Helpers.XULRT =
	{
		hostapps:
		{
			"{ec8030f7-c20a-464f-9b0e-13a3a9e97384}":
			{
				name: 		"Firefox",
				mainwindow:	"navigator:browser",
/*				openurl:	function(url)
				{
					let win = $xre.MostRecentAppWindow;
					if(win)
					{
						let tab = win.getBrowser().addTab(url);
						win.getBrowser().selectedTab = tab;
						win.focus();
					}
					else
						window.open(url);
				}
*/				openurl:	function(url)
					let(win = $xre.MostRecentAppWindow)
						win ? 
						let(tab = win.getBrowser().addTab(url))
							(win.getBrowser().selectedTab = tab, win.focus()) :
						window.open(url)
			},
			"{3550f703-e582-4d05-9a08-453d09bdfdc6}":
			{
				name:		"Thunderbird",
				mainwindow:	"mail:3pane"
			},
			"{136c295a-4a5a-41cf-bf24-5cee526720d5}":
			{
				name:		"Nvu"
			},
			"{86c18b42-e466-45a9-ae7a-9b95ba6f5640}":
			{
				name:	"Mozilla Suite"
			},
			"{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}":
			{
				name: 	"SeaMonkey",
				mainwindow:	"navigator:browser",
				openurl:	function(url)
					let(win = $xre.MostRecentAppWindow)
						win ? 
						let(tab = win.getBrowser().addTab(url))
							(win.getBrowser().selectedTab = tab, win.focus()) :
						window.open(url)
			},
			"{718e30fb-e89b-41dd-9da7-e25a45638b28}":
			{
				name: 	"Sunbird"
			},
			"{3db10fab-e461-4c80-8b97-957ad5f8ea47}":
			{
				name: 	"Netscape Browser"
			},
			"{a463f10c-3994-11da-9945-000d60ca027b}":
			{
				name: 	"Flock Browser"
			},
			"{a23983c0-fd0e-11dc-95ff-0800200c9a66}":
			{
				name:	"Fennec"
			},
			"{136c295a-4a5a-41cf-bf24-5cee526720d5}":
			{
				name:	"KompoZer"
			},
			"{20aa4150-b5f4-11de-8a39-0800200c9a66}":
			{
				name:	"KompoZer 0.8"
			},
			"{8fa6f1b4-7ed3-4895-bac6-01f1cc206ab3}":
			{
				name: 	"BlueGriffon"
			},
			"{b1042fb5-9e9c-11db-b107-000d935d3368}":
			{
				name: 	"Komodo Edit"
			},
			"prism@developer.mozilla.org":
			{
				name:	"Prism"
			},
			"dlm4@emusic.com":
			{
				name:	"eMusic Download Manager"
			},
			
			// default or if no id found
			//
			null:
			{
				name:		"[failed to recognize host application]",
				mainwindow:	"navigator:browser",
				openurl:	function(url)
					let (uri = $u.url(url))
						$xpc.service.byid("@mozilla.org/uriloader/external-protocol-service;1",
								"nsIExternalProtocolService").loadURI(uri, null)
			}
		},
	
		get ProfileDir() 
		{
			return $xpc.service.byid("@mozilla.org/file/directory_service;1", "nsIProperties").
					get("ProfD", Ci.nsILocalFile);
		},
		
		get MainAppWindow()
		{
			return window.QueryInterface(Ci.nsIInterfaceRequestor).
					getInterface(Ci.nsIWebNavigation).
					QueryInterface(Ci.nsIDocShellTreeItem).
					rootTreeItem.
					QueryInterface(Ci.nsIInterfaceRequestor).
					getInterface(Ci.nsIDOMWindow);
		},
	
		get MostRecentAppWindow()
		{
			let app = $xre.hostapps[$xre.hostenvinfo.app.id];
			let mainwindow = app.mainwindow || $xre.hostapps[null].mainwindow;
			return $xpc.service.byid("@mozilla.org/appshell/window-mediator;1","nsIWindowMediator").
					getMostRecentWindow(mainwindow);
		},

		OpenURL: function(url)
		{
			let app = $xre.hostapps[$xre.hostenvinfo.app.id];
			let openurl = app.openurl || $xre.hostapps[null].openurl;
			openurl(url);
		},
		

		_hostenvinfo: null,
		// .os, .app.name, .app.id, .app.version, app.unbrandedname
		get hostenvinfo()
		{
			if(!$xre._hostenvinfo)
			{
				// Windows -- "WINNT"
				// GNU/Linux -- "Linux"
				// MacOSX -- "Darwin" 
				$xre._hostenvinfo = { app: {} };
				$xre._hostenvinfo.os = $xpc.service.byid("@mozilla.org/xre/app-info;1", "nsIXULRuntime").OS;
				let appinfo = $xpc.service.byid("@mozilla.org/xre/app-info;1", "nsIXULAppInfo");
				[
					$xre._hostenvinfo.app.name,
					$xre._hostenvinfo.app.id,
					$xre._hostenvinfo.app.version,
				] =
				[
					appinfo.name,
					appinfo.ID,
					appinfo.version,
				];
				let app = $xre.hostapps[appinfo.ID];
				$xre._hostenvinfo.app.unbrandedname = app ? app.name : $xre.hostapps[null].name;
			}
			return $xre._hostenvinfo;
		},
		
		get locale()
		{
			return $xpc.service.byid("@mozilla.org/intl/stringbundle;1", "nsIStringBundleService").
					createBundle("chrome://global/locale/intl.properties").
					GetStringFromName("general.useragent.locale");
		}
		
	}
}